#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <vector>
#include <algorithm>
#include <iomanip>

using namespace std;

vector<pair<int, int> > a;

int main() {
    ios_base::sync_with_stdio(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int n, m;
    cin >> n >> m;
    a.resize(m+1);
    vector<vector<int> > f(m+1, vector<int> (n+1));
    for (int i=1; i<=m; i++) {
        cin >> a[i].first;
        a[i].second = i;
    }

    vector<vector<int> > p(m+1, vector<int> (n+1));
    sort(a.begin(), a.end());
    for (int i=1; i<=m; i++) {
        for (int j=1; j<=n; j++) {
            if (j == 1) {
                f[i][j] = a[i].first;
            } else {
                for (int l=1; l<i; l++) {
                    int kk = a[i].first - a[l].first;
                    int tmp =  min(f[l][j-1], kk);
                    if (f[i][j] < tmp) {
                        f[i][j] = tmp;
                        p[i][j] = l;
                    }
                }
            }
        }
    }
    vector<int> ans;
    ans.reserve(n);
    int pr = 0, mx = 0;
    for (int i=1; i<=m; i++){
        if (f[i][n] > mx) {
            mx = f[i][n];
            pr = i;
        }
    }
    int k = n;
    while (pr != 0){
        ans.push_back(pr);
        pr = p[pr][k];
        k--;
    }
    for (int i=ans.size()-1;i>=0;i--)
        cout << a[ans[i]].second  << " ";

    return 0;
}
