#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <map>

using namespace std;

#define mkp(a, b) make_pair(a, b)
#define F first
#define S second
#define SQR(a) ((a)*(a))
#define INF (1<<30)

int n, m;
vector<int> a;
map<int, int> pos;
vector<int> ans;
int mxdist = 0;

int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    scanf("%d %d", &n, &m);
    a.resize(m);
    for(int i = 0; i < m; i++)
    {
        scanf("%d", &a[i]);
        pos[a[i]] = i + 1;
    }

    sort(a.begin(), a.end());

    if(m <= 28)
    {
        for(long long i = (1 << (m+1)) - 1; i >= 0; i--)
        {
            vector<int> temp;
            int oc = 0; // Ones count
            for(int j = 0; j < m; j++)
                if(((1 << j) & i) > 0)
                    oc++;
            if(oc != n)
                continue;
            temp.reserve(n);
            for(int j = 0; j < m; j++)
                if(((1 << j) & i) > 0)
                    temp.push_back(a[j]);
            int mnd = temp[0];
            for(int j = 1; j < n; j++)
                if(temp[j] - temp[j-1] < mnd )
                    mnd = temp[j] - temp[j-1];
            if(mnd > mxdist)
            {
                mxdist = mnd;
                ans = temp;
            }
        }
        for(int i = 0; i < n; i++)
            printf("%d ", pos[ans[i]]);
        exit(0);
    }
    for(int i = 1; i <= n; i++)
        cout << i << endl;
    exit(0);
}
