#include <iostream>
#include <cstdlib>
#include <iomanip>
#include <cstring>
#include <string>
#include <algorithm>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <vector>
#include <ctime>
#include <fstream>
#include <cmath>

using namespace std;


#define F first
#define S second

int n, m;
int a[2050][2050];
int d[2050][2050];
string s;
int main() {

    ios_base::sync_with_stdio(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    cin >> n >> m;
    getline(cin, s);
    int k;
    for (int i = 0; i < n; ++i) {
        getline(cin, s);
        k = 0;
        for (int j = 0; j < s.size(); ++j) {
            if (s[j] == '1' || s[j] == '0') {
                a[i][k] = s[j] - '0';
                k++;
            }
        }
    }

    long long ans = 0;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i][j] == 1) {
                d[i][j] = 0;
                continue;
            }
            d[i][j] = 0;
            if (i > 0)
                d[i][j] = d[i - 1][j];
            if (j > 0)
                d[i][j] = min(d[i][j], d[i][j - 1]);
            if (i > 0 && j > 0)
                d[i][j] = min(d[i][j], d[i - 1][j - 1]);
            if (i == 0 || j == 0)
                d[i][j] = 0;
            d[i][j]++;
            ans += d[i][j];
        }
    }

    cout << ans << endl;

    return 0;
}
