#include <iostream>
#include <fstream>
#include <cstdio>
#include <vector>
#include <ctime>

#define pb push_back

using namespace std;

typedef vector<int> vi;
typedef long long ll;

int f[2005][2005];

int main() {
    ios_base::sync_with_stdio(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int n, m;
    scanf("%d %d\n", &n, &m);
    ll ans = 0;
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            char c;
            while (c = getchar())
                if (c == '0' || c == '1')
                    break;
            if (c == '0')
                f[i][j] = min(f[i - 1][j], min(f[i - 1][j - 1], f[i][j - 1])) + 1;
            ans += f[i][j];
        }
    }
    cout << ans << endl;
    return 0;
}
