#include <cstdio>
#include <deque>
#include <iostream>
#include <iomanip>
#include <string>
#include <cstring>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <ctime>

using namespace std;

#define F first
#define S second
#define pb push_back
#define mp make_pair

const int INF = 2000000000;

vector<int> num;
vector<int> c;
int main(){
    ios_base::sync_with_stdio(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int n, m;
    cin >> n >> m;
    vector<pair<int, int> > t;
    int dx, dy;
    for (int i = 0; i < m; i++) {
        cin >> dx;
        t.pb(mp(dx, i + 1));
    }
    sort(t.begin(), t.end());
    num.assign(m, 0);
    c.assign(m, 0);
    for (int i = 0; i < m; i++) {
        num[i] = t[i].S;
        c[i] = t[i].F;
    }
    int l = 0;
    int r = INF;
    int ans = -1;
    while (l <= r) {
        int mid = (l + r) / 2;
        int lst = 0;
        int cnt = 0;
        for (int i = 0; i < m; i++) if (c[i] - lst >= mid) {
            cnt++;
            lst = c[i];
        }
        if (cnt >= n) {
            ans = mid;
            l = mid + 1;
        } else {
            r = mid - 1;
        }
    }

    vector<int> v;
    int lst = 0;
    for (int i = 0; i < m; i++) {
        if (c[i] - lst >= ans) {
            v.pb(num[i]);
            lst = c[i];
        }
    }
    for (int i = 0; i < n; i++) cout << v[i] << " ";
    return 0;
}
