#include <iostream>
#include <cstdlib>
#include <iomanip>
#include <cstring>
#include <string>
#include <algorithm>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <vector>
#include <fstream>
#include <cmath>

using namespace std;

#ifndef LOCAL
#define cerr if(0)cerr
#endif
#define pb push_back
#define mp make_pair
#define F first
#define S second

typedef long long ll;
//typedef pair<int, int> pii;
//typedef pair<ll, ll> pll;
//typedef vector<int> vi;
//typedef vector<pii > vpii;
//typedef vector<vi > vvi;


const int INFint = 2147483647;
const ll INF = 9223372036854775807ll;
const ll MOD = 1000000007ll;


void solve1(int n, int m){
	vector<pair<ll, int> > a(m);
	for(int i = 0; i < m; i++) {
		cin >> a[i].F;
		a[i].S = i;
	}
	vector<pair<ll, int> > ansv;
	ll mxr = 0;
	for(int mask = 0; mask < (1 << m); mask++){
		vector<pair<ll, int> >  curv;
		int cnt = 0;
		for(int j = 0; j < m; j++){
			if (((1 << j) & mask) > 0){
				cnt++;
				curv.pb(a[j]);
			}
		}
		if (cnt != n) continue;
		ll pv = 0;
		ll mx = INF;
		sort(curv.begin(), curv.end());
			for(int i = 0; i < curv.size(); i++){
				//cerr << curv[i].S  + 1<< ' ';
				//cur+= abs(pv - curv[i].F);
				mx = min(mx, abs(pv - curv[i].F));
				pv = curv[i].F;
			}
			if (mxr < mx){
				mxr = mx;
				ansv = curv;
			}

	}
	for(int i = 0; i < ansv.size(); i++) cout << ansv[i].S + 1 << ' ';
}

int main(){
    ios_base::sync_with_stdio(0);
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	int n, m;
	cin >> n >> m;
	if (n == m){
		vector<pair<int, int> > a(m);
		for(int i = 0; i < m; i++) {
			cin >> a[i].F;
			a[i].S = i;
		}
		sort(a.begin(), a.end());
		for(int i = 0; i < n; i++) cout <<a[i].S + 1<< ' ';
		return 0;
	}
	solve1(n, m);

    return 0;
}
