#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <vector>
#include <algorithm>
#include <iomanip>

using namespace std;

int a[2010][2010];
long long f[2010][2010];

int main(){
    ios_base::sync_with_stdio(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int n, m;
    cin >> n >> m;
    for (int i=1;i<=n;i++)
        for (int j=1;j<=m;j++)
            cin >> a[i][j];
    long long ans = 0;
    for (int i=1;i<=n;i++){
        for (int j=1;j<=m;j++){
            if (a[i][j] == 1)
                f[i][j] = 0;
            else
                f[i][j] = min(min(f[i-1][j], f[i][j-1]), f[i-1][j-1]) + 1;
            ans += f[i][j];
        }
    }
    cout << ans << endl;
    return 0;
}
