#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>

using namespace std;

#define mkp(a, b) make_pair(a, b)
#define F first
#define S second
#define SQR(a) ((a)*(a))
#define INF (1<<30)

int n, m;
vector< vector< int > > a, f;
long long sum = 0;


int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    scanf("%d %d", &n, &m);
    a.resize(n, vector<int>(m));
    f.resize(n, vector<int>(m));
    for(int i = 0; i < n; i++)
        for(int j = 0; j < m; j++)
            scanf("%d", &a[i][j]);

    for(int i = 0; i < n; i++)
        f[i][0] = 1 - a[i][0];
    for(int j = 0; j < m; j++)
        f[0][j] = 1 - a[0][j];

    for(int i = 1; i < n; i++)
        for(int j = 1; j < m; j++)
            if(a[i][j] == 1)
                f[i][j] = 0;
            else if(!a[i][j] && (a[i-1][j] || a[i][j-1]))
                f[i][j] = 1;
            else
                f[i][j] = f[i-1][j-1] + 1;
    for(int i = 0; i < n; i++)
        for(int j = 0; j < m; j++)
            sum += f[i][j];
    cout << sum << endl;
    return 0;
}
